org.jgroups.protocols

## Class DAISYCHAIN

- java.lang.Object
- - org.jgroups.stack.Protocol
  - - org.jgroups.protocols.DAISYCHAIN

-     public class DAISYCHAIN
      extends Protocol

  Implementation of daisy chaining. Multicast messages are sent to our neighbor, which sends them to its neighbor etc. A TTL restricts the number of times a message is forwarded. The advantage of daisy chaining is that - for point-to-point transports such as TCP - we can avoid the N-1 issue: when A sends a multicast message to 10 members, it needs to send it 9 times. With daisy chaining, it sends it 1 time, and in the next round, can already send another message. This leads to much better throughput, see the ref in the JIRA.

  Should be inserted just above MERGE2, in TCP based configurations. JIRA: https://jira.jboss.org/browse/JGRP-1021
  Since:
    2.11
  Author:
    Bela Ban

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `DAISYCHAIN.DaisyHeader`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected java.util.concurrent.Executor` | `default_pool`
    `protected boolean` | `forward`
    `protected java.util.concurrent.BlockingQueue<Message>` | `forward_queue`
    `protected Address` | `local_addr`
    `int` | `msgs_forwarded`
    `int` | `msgs_sent`
    `protected Address` | `next`
    `protected java.util.concurrent.Executor` | `oob_pool`
    `protected boolean` | `running`
    `protected java.util.concurrent.BlockingQueue<Message>` | `send_queue`
    `protected int` | `view_size`

    - ### Fields inherited from class org.jgroups.stack.Protocol

      `down_prot, ergonomics, id, log, name, stack, stats, up_prot`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DAISYCHAIN()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.Object` | `down(Event evt)` An event is to be sent down the stack.
    `int` | `getElementsInForwardQueue()`
    `int` | `getElementsInSendQueue()`
    `protected void` | `handleView(View view)`
    `void` | `init()` Called after instance has been created (null constructor) and before protocol is started.
    `protected java.lang.Object` | `processQueues()`
    `void` | `start()` This method is called on a `Channel.connect(String)`.
    `void` | `stop()` This method is called on a `Channel.disconnect()`.
    `java.lang.Object` | `up(Event evt)` An event was received from the layer below.

    - ### Methods inherited from class org.jgroups.stack.Protocol

      `destroy, downThreadEnabled, dumpStats, enableStats, getConfigurableObjects, getDownProtocol, getId, getLevel, getName, getProperties, getProtocolStack, getSocketFactory, getThreadFactory, getTransport, getUpProtocol, getValue, isErgonomics, printStats, providedDownServices, providedUpServices, requiredDownServices, requiredUpServices, resetStats, setDownProtocol, setErgonomics, setId, setLevel, setProperties, setPropertiesInternal, setProperty, setProtocolStack, setSocketFactory, setUpProtocol, setValue, setValues, statsEnabled, upThreadEnabled`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### local_addr

          protected Address local_addr

    - #### next

          protected Address next

    - #### view_size

          protected int view_size

    - #### default_pool

          protected java.util.concurrent.Executor default_pool

    - #### oob_pool

          protected java.util.concurrent.Executor oob_pool

    - #### send_queue

          protected java.util.concurrent.BlockingQueue<Message> send_queue

    - #### forward_queue

          protected java.util.concurrent.BlockingQueue<Message> forward_queue

    - #### forward

          protected volatile boolean forward

    - #### running

          protected volatile boolean running

    - #### msgs_forwarded

          public int msgs_forwarded

    - #### msgs_sent

          public int msgs_sent

  - ### Constructor Detail

    - #### DAISYCHAIN

          public DAISYCHAIN()

  - ### Method Detail

    - #### getElementsInForwardQueue

          public int getElementsInForwardQueue()

    - #### getElementsInSendQueue

          public int getElementsInSendQueue()

    - #### init

          public void init()
                    throws java.lang.Exception

      Description copied from class: `Protocol`
      Called after instance has been created (null constructor) and before protocol is started. Properties are already set. Other protocols are not yet connected and events cannot yet be sent.
      Overrides:
        `init` in class `Protocol`
      Throws:
        `java.lang.Exception` - Thrown if protocol cannot be initialized successfully. This will cause the ProtocolStack to fail, so the channel constructor will throw an exception

    - #### start

          public void start()
                     throws java.lang.Exception

      Description copied from class: `Protocol`
      This method is called on a `Channel.connect(String)`. Starts work. Protocols are connected and queues are ready to receive events. Will be called from bottom to top. This call will replace the START and START_OK events.
      Overrides:
        `start` in class `Protocol`
      Throws:
        `java.lang.Exception` - Thrown if protocol cannot be started successfully. This will cause the ProtocolStack to fail, so `Channel.connect(String)` will throw an exception

    - #### stop

          public void stop()

      Description copied from class: `Protocol`
      This method is called on a `Channel.disconnect()`. Stops work (e.g. by closing multicast socket). Will be called from top to bottom. This means that at the time of the method invocation the neighbor protocol below is still working. This method will replace the STOP, STOP_OK, CLEANUP and CLEANUP_OK events. The ProtocolStack guarantees that when this method is called all messages in the down queue will have been flushed
      Overrides:
        `stop` in class `Protocol`

    - #### down

          public java.lang.Object down(Event evt)

      Description copied from class: `Protocol`
      An event is to be sent down the stack. The layer may want to examine its type and perform some action on it, depending on the event's type. If the event is a message MSG, then the layer may need to add a header to it (or do nothing at all) before sending it down the stack using `down_prot.down()`. In case of a GET_ADDRESS event (which tries to retrieve the stack's address from one of the bottom layers), the layer may need to send a new response event back up the stack using `up_prot.up()`.
      Overrides:
        `down` in class `Protocol`

    - #### up

          public java.lang.Object up(Event evt)

      Description copied from class: `Protocol`
      An event was received from the layer below. Usually the current layer will want to examine the event type and - depending on its type - perform some computation (e.g. removing headers from a MSG event type, or updating the internal membership list when receiving a VIEW_CHANGE event). Finally the event is either a) discarded, or b) an event is sent down the stack using `down_prot.down()` or c) the event (or another event) is sent up the stack using `up_prot.up()`.
      Overrides:
        `up` in class `Protocol`

    - #### processQueues

          protected java.lang.Object processQueues()

    - #### handleView

          protected void handleView(View view)

Copyright © 1998-2009 Bela Ban / Red Hat. All Rights Reserved.